Loading...
Searching...
No Matches
icu::LocaleBuilder Class Reference

`LocaleBuilder` is used to build instances of `Locale` from values configured by the setters. More...

`#include <localebuilder.h>`

Inheritance diagram for icu::LocaleBuilder:

## Public Member Functions

| LocaleBuilder ()
| Constructs an empty LocaleBuilder.
virtual | ~LocaleBuilder ()
| Destructor.
LocaleBuilder & | setLocale (const Locale &locale)
| Resets the `LocaleBuilder` to match the provided `locale`.
LocaleBuilder & | setLanguageTag (StringPiece tag)
| Resets the LocaleBuilder to match the provided IETF BCP 47 language tag.
LocaleBuilder & | setLanguage (StringPiece language)
| Sets the language.
LocaleBuilder & | setScript (StringPiece script)
| Sets the script.
LocaleBuilder & | setRegion (StringPiece region)
| Sets the region.
LocaleBuilder & | setVariant (StringPiece variant)
| Sets the variant.
LocaleBuilder & | setExtension (char key, StringPiece value)
| Sets the extension for the given key.
LocaleBuilder & | setUnicodeLocaleKeyword (StringPiece key, StringPiece type)
| Sets the Unicode locale keyword type for the given key.
LocaleBuilder & | addUnicodeLocaleAttribute (StringPiece attribute)
| Adds a unicode locale attribute, if not already present, otherwise has no effect.
LocaleBuilder & | removeUnicodeLocaleAttribute (StringPiece attribute)
| Removes a unicode locale attribute, if present, otherwise has no effect.
LocaleBuilder & | clear ()
| Resets the builder to its initial, empty state.
LocaleBuilder & | clearExtensions ()
| Resets the extensions to their initial, empty state.
Locale | build (UErrorCode &status)
| Returns an instance of `Locale` created from the fields set on this builder.
UBool | copyErrorTo (UErrorCode &outErrorCode) const
| Sets the UErrorCode if an error occurred while recording sets.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.
virtual UClassID | getDynamicClassID () const
| ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class.

## Friends

class | LocaleMatcher::Result

## Detailed Description

`LocaleBuilder` is used to build instances of `Locale` from values configured by the setters.

Unlike the `Locale` constructors, the `LocaleBuilder` checks if a value configured by a setter satisfies the syntax requirements defined by the `Locale` class. A `Locale` object created by a `LocaleBuilder` is well-formed and can be transformed to a well-formed IETF BCP 47 language tag without losing information.

The following example shows how to create a `Locale` object with the `LocaleBuilder`.

>         UErrorCode status = U_ZERO_ERROR;
>         Locale aLocale = LocaleBuilder()
>                              .setLanguage("sr")
>                              .setScript("Latn")
>                              .setRegion("RS")
>                              .build(status);
>         if (U_SUCCESS(status)) {
>           // ...
>         }

LocaleBuilders can be reused; `clear()` resets all fields to their default values.

LocaleBuilder tracks errors in an internal UErrorCode. For all setters, except setLanguageTag and setLocale, LocaleBuilder will return immediately if the internal UErrorCode is in error state. To reset internal state and error code, call clear method. The setLanguageTag and setLocale method will first clear the internal UErrorCode, then track the error of the validation of the input parameter into the internal UErrorCode.

Stable
  ICU 64

Definition at line 61 of file localebuilder.h.

## Constructor & Destructor Documentation

## LocaleBuilder()

icu::LocaleBuilder::LocaleBuilder | ( |  | ) |

Constructs an empty LocaleBuilder.

The default value of all fields, extensions, and private use information is the empty string.

Stable
  ICU 64

Referenced by addUnicodeLocaleAttribute(), clear(), clearExtensions(), removeUnicodeLocaleAttribute(), setExtension(), setLanguage(), setLanguageTag(), setLocale(), setRegion(), setScript(), setUnicodeLocaleKeyword(), and setVariant().

## ~LocaleBuilder()

virtual icu::LocaleBuilder::~LocaleBuilder | ( |  | ) |

virtual

Destructor.

Stable
  ICU 64

## Member Function Documentation

## addUnicodeLocaleAttribute()

LocaleBuilder & icu::LocaleBuilder::addUnicodeLocaleAttribute | ( | StringPiece | attribute | ) |

Adds a unicode locale attribute, if not already present, otherwise has no effect.

The attribute must not be empty string and must be well-formed or U_ILLEGAL_ARGUMENT_ERROR will be set to status during the build() call.

Parameters

  attribute | the attribute

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## build()

Locale icu::LocaleBuilder::build | ( | UErrorCode & | status | ) |

Returns an instance of `Locale` created from the fields set on this builder.

If any set methods or during the build() call require memory allocation but fail U_MEMORY_ALLOCATION_ERROR will be set to status. If any of the fields set by the setters are not well-formed, the status will be set to U_ILLEGAL_ARGUMENT_ERROR. The state of the builder will not change after the build() call and the caller is free to keep using the same builder to build more locales.

Returns
  a new Locale

Stable
  ICU 64

## clear()

LocaleBuilder & icu::LocaleBuilder::clear | ( |  | ) |

Resets the builder to its initial, empty state.

This method clears the internal UErrorCode.

Returns
  this builder

Stable
  ICU 64

References LocaleBuilder().

## clearExtensions()

LocaleBuilder & icu::LocaleBuilder::clearExtensions | ( |  | ) |

Resets the extensions to their initial, empty state.

Language, script, region and variant are unchanged.

Returns
  this builder

Stable
  ICU 64

References LocaleBuilder().

## copyErrorTo()

UBool icu::LocaleBuilder::copyErrorTo | ( | UErrorCode & | outErrorCode | ) | const

Sets the UErrorCode if an error occurred while recording sets.

Preserves older error codes in the outErrorCode.

Parameters

  outErrorCode | Set to an error code that occurred while setting subtags. Unchanged if there is no such error or if outErrorCode already contained an error.

Returns
  true if U_FAILURE(outErrorCode)

Stable
  ICU 65

## removeUnicodeLocaleAttribute()

LocaleBuilder & icu::LocaleBuilder::removeUnicodeLocaleAttribute | ( | StringPiece | attribute | ) |

Removes a unicode locale attribute, if present, otherwise has no effect.

The attribute must not be empty string and must be well-formed or U_ILLEGAL_ARGUMENT_ERROR will be set to status during the build() call.

Attribute comparison for removal is case-insensitive.

Parameters

  attribute | the attribute

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setExtension()

LocaleBuilder & icu::LocaleBuilder::setExtension | ( | char | key,
|  | StringPiece | value )

Sets the extension for the given key.

If the value is the empty string, the extension is removed. Otherwise, the `key` and `value` must be well-formed, or else the build() method will later report an U_ILLEGAL_ARGUMENT_ERROR.

Note: The key ('u') is used for the Unicode locale extension. Setting a value for this key replaces any existing Unicode locale key/type pairs with those defined in the extension.

Note: The key ('x') is used for the private use code. To be well-formed, the value for this key needs only to have subtags of one to eight alphanumeric characters, not two to eight as in the general case.

Parameters

  key | the extension key
  value | the extension value

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setLanguage()

LocaleBuilder & icu::LocaleBuilder::setLanguage | ( | StringPiece | language | ) |

Sets the language.

If `language` is the empty string, the language in this `LocaleBuilder` is removed. Otherwise, the `language` must be well-formed, or else the build() method will later report an U_ILLEGAL_ARGUMENT_ERROR.

The syntax of language value is defined as unicode_language_subtag.

Parameters

  language | the language

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setLanguageTag()

LocaleBuilder & icu::LocaleBuilder::setLanguageTag | ( | StringPiece | tag | ) |

Resets the LocaleBuilder to match the provided IETF BCP 47 language tag.

Discards the existing state. The empty string causes the builder to be reset, like `clear`. Legacy language tags (marked as “Type: grandfathered” in BCP 47) are converted to their canonical form before being processed. Otherwise, the `language tag` must be well-formed, or else the build() method will later report an U_ILLEGAL_ARGUMENT_ERROR.

This method clears the internal UErrorCode.

Parameters

  tag | the language tag, defined as IETF BCP 47 language tag.

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setLocale()

LocaleBuilder & icu::LocaleBuilder::setLocale | ( | const Locale & | locale | ) |

Resets the `LocaleBuilder` to match the provided `locale`.

Existing state is discarded.

All fields of the locale must be well-formed.

This method clears the internal UErrorCode.

Parameters

  locale | the locale

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setRegion()

LocaleBuilder & icu::LocaleBuilder::setRegion | ( | StringPiece | region | ) |

Sets the region.

If region is the empty string, the region in this `LocaleBuilder` is removed. Otherwise, the `region` must be well-formed, or else the build() method will later report an U_ILLEGAL_ARGUMENT_ERROR.

The region value is defined by unicode_region_subtag as a two-letter ISO 3166 code or a three-digit UN M.49 area code.

The region value in the `Locale` created by the `LocaleBuilder` is always normalized to upper case.

Parameters

  region | the region

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setScript()

LocaleBuilder & icu::LocaleBuilder::setScript | ( | StringPiece | script | ) |

Sets the script.

If `script` is the empty string, the script in this `LocaleBuilder` is removed. Otherwise, the `script` must be well-formed, or else the build() method will later report an U_ILLEGAL_ARGUMENT_ERROR.

The script value is a four-letter script code as unicode_script_subtag defined by ISO 15924

Parameters

  script | the script

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setUnicodeLocaleKeyword()

LocaleBuilder & icu::LocaleBuilder::setUnicodeLocaleKeyword | ( | StringPiece | key,
|  | StringPiece | type )

Sets the Unicode locale keyword type for the given key.

If the type StringPiece is constructed with a nullptr, the keyword is removed. If the type is the empty string, the keyword is set without type subtags. Otherwise, the key and type must be well-formed, or else the build() method will later report an U_ILLEGAL_ARGUMENT_ERROR.

Keys and types are converted to lower case.

Note:Setting the 'u' extension via `setExtension` replaces all Unicode locale keywords with those defined in the extension.

Parameters

  key | the Unicode locale key
  type | the Unicode locale type

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## setVariant()

LocaleBuilder & icu::LocaleBuilder::setVariant | ( | StringPiece | variant | ) |

Sets the variant.

If variant is the empty string, the variant in this `LocaleBuilder` is removed. Otherwise, the `variant` must be well-formed, or else the build() method will later report an U_ILLEGAL_ARGUMENT_ERROR.

Note: This method checks if `variant` satisfies the unicode_variant_subtag syntax requirements, and normalizes the value to lowercase letters. However, the `Locale` class does not impose any syntactic restriction on variant. To set an ill-formed variant, use a Locale constructor. If there are multiple unicode_variant_subtag, the caller must concatenate them with '-' as separator (ex: "foobar-fibar").

Parameters

  variant | the variant

Returns
  This builder.

Stable
  ICU 64

References LocaleBuilder().

## Friends And Related Symbol Documentation

## LocaleMatcher::Result

friend class LocaleMatcher::Result

friend

Definition at line 292 of file localebuilder.h.

The documentation for this class was generated from the following file:

- common/unicode/localebuilder.h